


//PS2dev mouse(3,2); // 2 data 3clock
//PS2dev keyboard(7,6); // PS2dev object (2:data, 3:clock)

char buttons[3] = {0,0,0};
int kbstat=1;
int msstat=1;

int delta_x = 0;
int delta_y = 0;
//we start off not enabled
int enabled =0;
int incomingByte=0;
int tempint=0;
int sr=20;
int rsl=0;
int oldcmd;

char commandbuf[10];
int bufcount=0;
char bufsym;

void fastdigitalwrite(int pin,int val){
  if(val==1){
    PORTD |= 1<<pin;
  }else{
    PORTD &= ~ 1<<pin;
  }
}

int fastdigitalread(int pin){
  return PIND & 1<<pin;
}

//ack a host command
/*void ack() {
  while(mouse.write(0xFA)!=0);
}

void ackkb() {
  //acknowledge commands
  while(keyboard.write(0xFA));
}

int kbdCmd(int command) {
  unsigned char val;
  switch (command) {
  case 0xFF: //reset
    ackkb();
    //the while loop lets us wait for the host to be ready
    while(keyboard.write(0xAA)!=0);
    break;
  case 0xFE: //resend
    ackkb();
    break;
  case 0xF6: //set defaults
    //enter stream mode
    ackkb();
    break;
  case 0xF5: //disable data reporting
    //FM
    enabled = 0;
    ackkb();
    break;
  case 0xF4: //enable data reporting
    //FM
    enabled = 1;
    ackkb();
    break;
  case 0xF3: //set typematic rate
    ackkb();
    keyboard.read(&val); //do nothing with the rate
    ackkb();
    break;
  case 0xF2: //get device id
    ackkb();
    keyboard.write(0xAB);
    keyboard.write(0x83);
    break;
  case 0xF0: //set scan code set
    ackkb();
    keyboard.read(&val); //do nothing with the rate
    ackkb();
    break;
  case 0xEE: //echo
    //ack();
    keyboard.write(0xEE);
    break;
  case 0xED: //set/reset LEDs
    ackkb();
   // keyboard.read(&val); //do nothing with the rate
   // ackkb();
    break;
  case 0x0: // Такой команды нет, но есть такая заглушка, ответа не требуется 
    break;
  default: // Вообще на любую команду нужен ответ
    ackkb();
  } 
  if(command!=0xfe){ // Если не ошибка, то запоминаем последнюю команду
    oldcmd=command;
  }
}


void write_packet() {
  char overflowx =0;
  char overflowy =0;
  char data[3];
  int x,y;
  
  if (delta_x > 255) {
    overflowx =1;
    x=255;
  }
  if (delta_x < -255) {
    overflowx = 1;
    x=-255;
  }  
  if (delta_y > 255) {
    overflowy =1;
    y=255;
  }
  if (delta_y < -255) {
    overflowy = 1;
    y=-255;
  }
  
  data[0] = ((overflowy & 1) << 7) |
    ( (overflowx & 1) << 6) |
    ( (((delta_y &0x100)>>8) & 1) << 5) |
    ( ( ((delta_x &0x100)>>8)& 1) << 4) |
    ( ( 1) << 3) |
    ( ( buttons[1] & 1) << 2) |
    ( ( buttons[2] & 1) << 1) |
    ( ( buttons[0] & 1) << 0) ;
    
  data[1] = delta_x & 0xff;
  data[2] = delta_y & 0xff;
  
  
  while(mouse.write(data[0])!=0);
  while(mouse.write(data[1])!=0);  
  while(mouse.write(data[2])!=0);
  //while(mouse.write(0x00)!=0); // Scroll
  printserial(data[0]);
  printserial(data[1]);
  printserial(data[2]);
  

  delta_x = 0;
  delta_y = 0;
}*/

void printserial(int c){
    Serial.print("Device: 0x");
    Serial.println(c, HEX);
}
void printhost(int c){
    Serial.print("Host: 0x");
    Serial.println(c, HEX);
}
/*
int mousecommand(int command) {
  unsigned char val;

  //This implements enough mouse commands to get by, most of them are
  //just acked without really doing anything

  switch (command) {
  case 0xFF: //reset
    ack();
    //the while loop lets us wait for the host to be ready

    while(mouse.write(0xAA)!=0);  
    while(mouse.write(0x00)!=0);
  
    break;
  case 0xFE: //resend
    //ack();
    mousecommand(oldcmd); // рекурсивный повтор предыдущей команды - возможен сбой при частых ошибках.
    break;
  case 0xF6: //set defaults 
    //enter stream mode   
    ack();
    break;
  case 0xF5:  //disable data reporting
    //FM
    ack();
    break;
  case 0xF4: //enable data reporting
    //FM
    enabled = 1;
    ack();
    break;
  case 0xF3: //set sample rate
    ack();
    mouse.read(&val); // for now drop the new rate on the floor
    ack();
    sr=val; // надо запомнить, что от нас хочет хост
    printhost(val);
    break;
  case 0xF2: //get device id
    ack();
    while(mouse.write(0x00)!=0);
    break;
  case 0xF0: //set remote mode 
    ack();  
    break;
  case 0xEE: //set wrap mode
    ack();
    break;
  case 0xEC: //reset wrap mode
    ack();
    break;
  case 0xEB: //read data
    ack();
    write_packet();
    break;
  case 0xEA: //set stream mode
    ack();
    break;
  case 0xE9: //status request
    ack();
    while(mouse.write(0xE6)!=0); // Даем инфу о настройках мыши 
    while(mouse.write(rsl)!=0);  // и если потребуется запомненные от хоста параметры,
    while(mouse.write(sr)!=0);   // если тот проверить захочет
    //      send_status();
    break;
  case 0xE8: //set resolution
    ack();
    mouse.read(&val);
    ack();
    rsl=val; // Запоминаем параметры
    printhost(val);
    break;
  case 0xE7: //set scaling 2:1
    ack();
    break;
  case 0xE6: //set scaling 1:1
    ack();
    break;
  case 0x0: // Такой команды нет, но есть такая заглушка, ответа не требуется 
    break;
  default: // Вообще на любую команду нужен ответ
    ack();
  } 
  if(command!=0xfe){ // Если не ошибка, то запоминаем последнюю команду
    oldcmd=command;
  }
}*/

int xcenter ;
int ycenter;

int xsum = 0;
int ysum = 0;

void setup() {
  unsigned char val;

  Serial.begin(9600);
  
  Serial.println("\nSerial Host Connected");
  Serial.flush();
  Serial.println(PIND,BIN);
  // При старте ничего отправлять хосту не требуется, только если тот попросит.
  // Более того, если отправить вдруг (после инициализации мыши хостом) AA и 00,  
  // то хост опустит clock и на этом все закончится - требуется перезагрузка хоста.
}


int SerialreadHEX(byte c){
  
  if(c>-'0' && c<='9'){
    return c - '0';
  } 
  else if (c>='a' && c<='f'){
    return c - 'a'+10;
  } 
  else if (c>='a' && c<='f'){
    return c - 'a'+10;
  } 
  else if (c>='A' && c<='F'){
    return c - 'A'+10;
  } 
  else {
    return -1;
  }
}

int char2hex(char a1,char a2){
         incomingByte=SerialreadHEX(a1);
         if(incomingByte>-1) {
           tempint=SerialreadHEX(a2);
           if (tempint>-1){
             incomingByte=(incomingByte*16)+tempint;
           }
         }
         if(incomingByte<0){
           incomingByte=0;
         }
         return incomingByte;    
}

void loop() {
  unsigned char  c;
  if (fastdigitalread(3)){
    msstat=1;
  }else{
    msstat=0;
  }
  if (fastdigitalread(7)){
    kbstat=1;
  }else{
    kbstat=0;
  }
  if( !msstat && (!fastdigitalread(2))) {
 /*
    //kb=1c;kb=9c;
    Serial.println(PIND,BIN);
    mouse.read(&c) ;   
    mousecommand(c);
    if(c!=0x00) printhost(c);
  }else if( !kbstat && (!fastdigitalread(6))) {
    Serial.println(PIND,BIN); 
    keyboard.read(&c);
    kbdCmd(c);
    if (c!=0x00){
      Serial.print("Target kbd: 0x");
      Serial.println(c, HEX);
    }*/
  }else{
    if(Serial.available() > 0) {
    /*  incomingByte=SerialreadHEX();
      delay(5);
      if(incomingByte>-1 && Serial.available() > 0) {
        tempint=SerialreadHEX();
        if (tempint>-1){
          incomingByte=(incomingByte*16)+tempint;
        }
      }
     */
     
     bufsym = Serial.read();
     if(bufcount>9){
       if(bufsym==';'){
         bufcount=0;
       }
     }else
     if(bufsym!=';'){
       commandbuf[bufcount]=bufsym;
       bufcount++;
     }else{
       if(commandbuf[0]=='k' && commandbuf[1]=='b' && commandbuf[2]=='=' && bufcount==5){
        // Serial.print(keyboard.write(char2hex(commandbuf[3],commandbuf[4])),DEC);
         Serial.print(" kbd write ");
         Serial.println(char2hex(commandbuf[3],commandbuf[4]),HEX);
       }
       if(commandbuf[0]=='m' && commandbuf[1]=='s' && commandbuf[2]=='=' && bufcount==9){
       //  mouse.write(char2hex(commandbuf[3],commandbuf[4]));
       //  mouse.write(char2hex(commandbuf[5],commandbuf[6]));
       //  mouse.write(char2hex(commandbuf[7],commandbuf[8]));
         Serial.println("mouse write ");
       }
       bufcount=0;
     }
    }
  }
/*  if (enabled) {
    // move the mouse diagonally
    delta_x = 1;
    delta_y = 1;
    write_packet();
  }*/

}
